<?php
################################################################################
# @Name : mail2ticket.php
# @Description : convert mail to ticket
# @call : parameters in connector tab or using an external cron job
# @parameters : 
# @Author : Flox
# @Create : 07/04/2013
# @Update : 23/02/2017
# @Version : 3.1.18
################################################################################

//locales
$lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
if ($lang=='fr') {$_GET['lang'] = 'fr_FR';}
else {$_GET['lang'] = 'en_US';}

define('PROJECT_DIR', realpath('../'));
define('LOCALE_DIR', PROJECT_DIR .'/locale');
define('DEFAULT_LOCALE', '($_GET[lang]');
require_once('./components/php-gettext/gettext.inc');
$encoding = 'UTF-8';
$locale = (isset($_GET['lang']))? $_GET['lang'] : DEFAULT_LOCALE;
T_setlocale(LC_MESSAGES, $locale);
T_bindtextdomain($_GET['lang'], LOCALE_DIR);
T_bind_textdomain_codeset($_GET['lang'], $encoding);
T_textdomain($_GET['lang']);

//define encodage type 
header('Content-Type: text/html; charset=utf-8');

//call phpimap component
require_once('components/PhpImap/IncomingMail.php');
require_once('components/PhpImap/Mailbox.php');
use PhpImap\Mailbox as ImapMailbox;
use PhpImap\IncomingMail;
use PhpImap\IncomingMailAttachment;

//function to add attachment in image on ticket
function func_attachement($c_ticket_number,$c_name_dir_upload,$mail,$db)
{
	$c_name_dir_ticket = $c_name_dir_upload.$c_ticket_number; 
	//move attachment to upload directory
	$tabAttachments = $mail->getAttachments();
	foreach ($tabAttachments as $tabAttachment){
		@mkdir($c_name_dir_upload.$c_ticket_number);
		//case image inside in mail
		if($tabAttachment->disposition=="inline" || $tabAttachment->disposition==null) 
		{
			$c_name_file = basename($tabAttachment->filePath);
			echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Image into body= $c_name_file <br />";
			$dispo=$tabAttachment->disposition;
			echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Disposition= $dispo <br />";
		} 
		//case attachment in mail
		else 
		{
			$c_name_file = $tabAttachment->name;
			echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Attachment= $c_name_file <br />";
			$dispo=$tabAttachment->disposition;
			echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Disposition= $dispo <br />";
			$query=$db->query("SELECT img1,img2,img3,img4,img5 FROM tincidents WHERE id LIKE '$c_ticket_number'");
			$row=$query->fetch();
			$query->closeCursor();

			//find the first free slot else not display attach input
			if ($row['img1']=="") {$freeslot="img1";}
			else if ($row['img2']=="") {$freeslot="img2";}
			else if ($row['img3']=="") {$freeslot="img3";}
			else if ($row['img4']=="") {$freeslot="img4";}
			else if ($row['img5']=="") {$freeslot="img5";}

			if(isset($freeslot)){
				echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Freeslot selected= $freeslot <br />";
				$db->query("UPDATE tincidents SET $freeslot='$c_name_file' WHERE id='$c_ticket_number'");
			}
		}
		rename($tabAttachment->filePath,$c_name_dir_ticket.'/'.$c_name_file); 
	}
	return $mail->replaceInternalLinks('upload/'.$c_ticket_number);
}

//initialize counter
$count=0;

//connexion script with database parameters
require "connect.php";

//switch SQL MODE to allow empty values with lastest version of MySQL
$db->exec('SET sql_mode = ""');

//define current time
$datetime = date("Y-m-d H:i:s");

//load parameters table
$query=$db->query("SELECT * FROM tparameters");
$rparameters=$query->fetch();
$query->closeCursor(); 	

//hostname building
$hostname = '{'.$rparameters['imap_server'].':'.$rparameters['imap_port'].'}'.$rparameters['imap_inbox'].'';

//connect to in-box
echo "<u></u>Mailbox connection: <font color=green>OK</font><br /><br />";
$c_name_dir_upload =  __DIR__.'/upload/';
$con_mailbox = new PhpImap\Mailbox($hostname, $rparameters['imap_user'], $rparameters['imap_password'],$c_name_dir_upload) or die(T_('Impossible de se connecter au serveur de Messagerie: ') . imap_last_error());
if (!$con_mailbox ) {
	die("Error on IMAP connection");
}

//check mail in mailbox
$mailsIds = $con_mailbox ->searchMailBox('ALL');
if(!$mailsIds) {
    die('Mailbox is empty');
}

//treatment for all mail inside mailbox
$tab_MailsInfos =  $con_mailbox ->getMailsInfo($mailsIds); 
foreach ($tab_MailsInfos as $tab_MailsInfo){
	if($tab_MailsInfo->seen==0) 
	{
		$count=$count+1;
		$mail = $con_mailbox ->getMail($tab_MailsInfo->uid);
		$from = $mail->fromAddress;
		$subject = $mail->subject;
		$blacklist_mail=0;
		//detect blacklist mail or domain for exclusion
		if($rparameters['imap_blacklist']!='')
		{
			$mail_blacklist=explode(';',$rparameters['imap_blacklist']);
			foreach ($mail_blacklist as $value) {
				//check if each blacklist value exit in source mail as sender
				if (preg_match("/$value/i", $from)){$blacklist_mail=1;}
			}
		}
		if($blacklist_mail==1) {
			echo "&nbsp> Import message $count : $subject <font color=red>KO</font> (blacklist detected on $from)<br />";
		} 
		else
		{
			if($mail->textHtml == NULL){
				$contentype='textPlain';
				$message = nl2br($mail->textPlain);
				$description = nl2br($mail->textPlain);
			}else{
				$contentype='textHtml';
				$message = $mail->textHtml;
				$description = $mail->textHtml;
			}
			
			//special char convert
			$subject = str_replace('_', ' ', $subject);

			//find gestsup userid from mail address
			$query=$db->query("SELECT id FROM `tusers` where mail='$from' ");
			$row=$query->fetch();
			$query->closeCursor();
			if($row[0])
			{
				$user_id=$row[0];
			} else {
				$user_id='0';
				$c_FromMessage='De '.$from.':<br />';
			}
			
			//detect ticket number in subject to update an existing ticket
			$c_reg = "/n°(.*?):/i"; //regex for extract ticket number
			preg_match($c_reg, $subject, $matches); // extract ticket number
			@$find_ticket_number = $matches[1];
			if ($find_ticket_number!="")
			{
				//get attachement and image 
				$message = (isset($c_FromMessage)?$c_FromMessage:'').func_attachement($find_ticket_number,$c_name_dir_upload,$mail,$db); 
				//delete ticket part from mail to keep only answer
				$end_tag='---- '.T_('Vous pouvez répondre à ce ticket via ce mail, écrivez au dessus du ticket').' ----';
				$start_tag='---- '.T_('Vous pouvez répondre à ce ticket via ce mail, écrivez au dessus de cette ligne').' ----';
				$end_mail=explode($end_tag,$message);
				$end_mail=$end_mail[1];
				$start_mail=explode($start_tag,$message);
				$start_mail=$start_mail[0];
				$message=$start_mail.$end_mail;	
				
				//sanitize HTML code
				$message=str_replace('text-decoration:underline;','',$message);
				if (!preg_match("/<HTML/i",$message)){$message=strip_tags($message,'<p><a><span><br>');}
				
				//update ticket
				$stmt = $db->prepare("INSERT INTO tthreads (ticket,date,author,text) VALUES (?,?,?,?)");
				$stmt->bindParam(1, $find_ticket_number);
				$stmt->bindParam(2, $datetime);
				$stmt->bindParam(3, $user_id);
				$stmt->bindParam(4, $message);
				$stmt->execute();

				echo "&nbsp> Import message $count : $subject <font color=green>OK</font><br />";
				if($rparameters['debug']==1) 
				{
					echo"
					&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Update an existing ticket.<br />
					&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- ContentType= $contentype <br />
					";
				}
				//update unread state
				$db->exec("UPDATE tincidents SET techread=0 WHERE id='$find_ticket_number'");
				
			} else {
				//create ticket
				$stmt = $db->prepare("INSERT INTO tincidents (user,technician,title,description,date_create,techread,state,criticality,disable,place,creator) 
							VALUES (?,'0',?, '',?,'0','5','4','0','0',?)");
				$stmt->bindParam(1, $user_id);
				$stmt->bindParam(2, $subject);
				$stmt->bindParam(3, $datetime);
				$stmt->bindParam(4, $user_id);
				$stmt->execute();
				
				//get ticket number
				$c_ticket_number = $db->lastInsertId();
				
				echo "&nbsp> Import message $count : $subject <font color=green>OK</font><br />";
				if($rparameters['debug']==1) 
				{
					echo"
					&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Create new ticket with ID= <a href=\"index.php?page=ticket&id=$c_ticket_number\" target=\"about_blank\" >$c_ticket_number</a> <br />
					&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- ContentType= $contentype <br />
					";
				}
				//get attachement and images from mail
				$message = (isset($c_FromMessage)?$c_FromMessage:'').func_attachement($c_ticket_number,$c_name_dir_upload,$mail,$db);
				
				if($contentype=='textPlain')
				{
					$description=$db->quote($description);
					$db->query("UPDATE tincidents SET description=$description WHERE id='$c_ticket_number'");
				}
				else //html case
				{
					//remove outlook string to avoid underline application problem
					$message=str_replace("text-decoration:underline;", "", $message);
					$message=$db->quote($message);
					$query="UPDATE tincidents SET description=$message WHERE id='$c_ticket_number'";
					$db->query($query);
				}
			}
			//post treatment action
			if ($rparameters['imap_post_treatment']=='move' && $rparameters['imap_post_treatment_folder']!='')
			{
				//move mail
				$con_mailbox->moveMail($tab_MailsInfo->uid,$rparameters['imap_post_treatment_folder']);
				echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Post-treatment= MOVED in $rparameters[imap_post_treatment_folder] <br />";
			}
			if ($rparameters['imap_post_treatment']=='delete')
			{
				//delete mail
				imap_delete($con_mailbox->getImapStream(),$tab_MailsInfo->uid,FT_UID);
				echo "&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp- Post-treatment= DELETED <br />";
			}
		}
	}
}
echo "<br />Total $count messages received from <b>$rparameters[imap_server]:$rparameters[imap_port]</b><br />";
?>